//+------------------------------------------------------------------+
//|                                                   DailyCCIEA.mq4 |
//|                             Based on Steven Ali trading strategy |
//|                                       Copyright  2006, firedave | 
//|                    Partial Function Copyright  2006, codersguru | 
//|                        Partial Function Copyright  2006, pengie | 
//|                                        http://www.fx-review.com/ | 
//|                                        http://www.forex-tsd.com/ | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, firedave"
#property link      "http://www.fx-review.com"

//+------------------------------------------------------------------+
//| INCLUDES FILES                                                   |
//+------------------------------------------------------------------+
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| EXPERT ADVISOR EXTERN VARIABLE                                   |
//+------------------------------------------------------------------+
extern string  
         Expert_Name       = "---------- DailyCCI EA v1",
         Chart_Setting     = "---------- Please use on Hourly Chart";
extern int
         MagicN            = 1234;
extern double 
         StopLoss          = 70,
         TakeProfit        = 30,
         TrailingStop      = 0;

extern string  
         Indicator_Setting = "---------- Indicator Setting";
extern int
         CCItimeframe      = 1440,
         CCIperiod         = 14,
         CCIprice          = 0;
          
extern string  
         Order_Setting     = "---------- Order Setting";
extern int
         NumberOfTries     = 5,
         Slippage          = 5;
extern bool
         OneEntryPerBar    = true,
         ReverseEntry      = false,
         StopAndReverse    = true,  // if signal change, exit and reverse order
         MultipleEntry     = true;

extern string  
         Time_Parameters1   = "---------- EA Active Time",
         Time_Parameters2   = "---------- IBFX : 7-21",
         Time_Parameters3   = "---------- FXDD : 9-23";
extern bool    
         UseHourTrade      = false;
extern int     
         StartHour         = 9,
         EndHour           = 23;
         
extern string  
         MM_Parameters     = "---------- Money Management";
extern double 
         Lots              = 1;
extern bool 
         MM                = false, //Use Money Management or not
         AccountIsMicro    = false; //Use Micro-Account or not
extern int 
         Risk              = 5; //10%
extern string  
         Testing_Parameters= "---------- Back Test Parameter";
extern bool
         PrintControl      = true;         

//+------------------------------------------------------------------+
//| EXPERT ADVISOR PROGRAM SETTING AND GLOBAL VARIABLES              |
//+------------------------------------------------------------------+
bool
         GenerateMagicN    = true,
         UseNewDate        = true;
string
         TimeFilterOn      = "ALL",
         TicketComment,
         TicketC           = "DailyCCIv1",
         LastTrade;         
static int
         MagicNumber,
         TimeFrame         = 0,
         TradeDate;
datetime
         CheckEntryTime;

//+------------------------------------------------------------------+
//| EXPERT ADVISOR ADDITIONAL GLOBAL VARIABLES                       |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| INITIALIZATION FUNCTION                                          |
//+------------------------------------------------------------------+
int init()
{
//+------------------------------------------------------------------+
//| BUILD MAGIC NUMBER AND TICKET COMMENT                            |
//+------------------------------------------------------------------+
   if(GenerateMagicN)
   {
      MagicNumber    = subGenerateMagicNumber(MagicN, Symbol(), Period());
      TicketComment  = StringConcatenate(TicketC, "-", Symbol(), "-", Period());
   }

//+------------------------------------------------------------------+
//| CHECK LAST OPEN TRADE                                            |
//+------------------------------------------------------------------+
   LastTrade = subCheckOpenTrade();
}

//+------------------------------------------------------------------+
//| DE-INITIALIZATION FUNCTION                                       |
//+------------------------------------------------------------------+
int deinit()
{
 
//+------------------------------------------------------------------+
//| PREVENT RE-COUNTING WHILE USER CHANGING TIME FRAME               |
//+------------------------------------------------------------------+
   TimeFrame=Period(); 
   return(0);
}


//+------------------------------------------------------------------+
//| EXPERT ADVISOR START                                             |
//+------------------------------------------------------------------+
int start()
{

//+------------------------------------------------------------------+
//| EXPERT ADVISOR LOCAL VARIABLES                                   |
//+------------------------------------------------------------------+
   double 
         CCIyesterday,
         CCItoday;
   int   
         cnt,
         ticket,
         total;
   bool
         BuyCondition,
         SellCondition,
         ExitBuy,
         ExitSell;
         
//+------------------------------------------------------------------+
//| CHECK CHART NEED MORE THAN 100 BARS                              |
//+------------------------------------------------------------------+
   if(Bars<100)
   {
      Print("bars less than 100");
      return(0);  
   }

//+------------------------------------------------------------------+
//| CHECK FOR NEW DAY                                                |
//+------------------------------------------------------------------+
   if(UseNewDate && TradeDate==TimeDay(iTime(NULL,TimeFrame,0))) return(0);
   
   TradeDate   = TimeDay(iTime(NULL,TimeFrame,0));

//+------------------------------------------------------------------+
//| TIME FILTER ON ALL EA ACTIVITY                                   |
//+------------------------------------------------------------------+
   if (TimeFilterOn=="ALL" && UseHourTrade)
   {
      if(!(Hour()>=StartHour && Hour()<=EndHour))
      {
         Comment("Non-Trading Hours!");
         return(0);
      }
   }

//+------------------------------------------------------------------+
//| MAINTAIN ANY OPEN TRADE                                          |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| TRAILING STOP                                                    |
//+------------------------------------------------------------------+
   if(TrailingStop>0 && subOrdersTotal()>0) subTrailingStop();

//+------------------------------------------------------------------+
//| GET VALUE FROM INDICATORS                                        |
//+------------------------------------------------------------------+
   CCIyesterday = iCCI(NULL,CCItimeframe,CCIperiod,CCIprice,1);
   CCItoday     = iCCI(NULL,CCItimeframe,CCIperiod,CCIprice,0);

//+------------------------------------------------------------------+
//| ENTRY & EXIT CONDITION                                           |
//+------------------------------------------------------------------+
   if(!ReverseEntry)
   {
      if(CCItoday>CCIyesterday)
      {
         BuyCondition  = true;
         ExitSell      = true;
      }
      else if(CCItoday<CCIyesterday)
      {
         SellCondition = true;
         ExitBuy       = true;
      }
   }
   else
   {
      if(CCItoday<CCIyesterday)
      {
         BuyCondition  = true;
         ExitSell      = true;
      }
      else if(CCItoday>CCIyesterday)
      {
         SellCondition = true;
         ExitBuy       = true;
      }
   }
   
//+------------------------------------------------------------------+
//| EXIT TRADE                                                       |
//+------------------------------------------------------------------+
   if((LastTrade=="BUY" && ExitBuy) || (LastTrade=="SELL" && ExitSell))
   {
      subCloseOrder();
      if(subOrdersTotal()>0) subCloseOrder();
   }

//+------------------------------------------------------------------+
//| ADJUST LOTS IF USING MONEY MANAGEMENT                            |
//+------------------------------------------------------------------+
   if(MM) Lots = subLotSize();

//+------------------------------------------------------------------+
//| NEW TRADE - ENTRY                                                |
//+------------------------------------------------------------------+
   if(BuyCondition || SellCondition) 
   {
      if(!MultipleEntry && subOrdersTotal()>0) return(0);
//+------------------------------------------------------------------+
//| TIME FILTER ON ENTRY                                             |
//+------------------------------------------------------------------+
      if(TimeFilterOn=="ENTRY" && UseHourTrade &&
         (Hour()<StartHour || Hour()>EndHour))
      {
         return(0);
      }

//+------------------------------------------------------------------+
//| ONE ENTRY PER BAR                                                |
//+------------------------------------------------------------------+
      if(OneEntryPerBar)
      {
         if(CheckEntryTime==iTime(NULL,TimeFrame,0)) return(0); else CheckEntryTime = iTime(NULL,TimeFrame,0);
      }         

//+------------------------------------------------------------------+
//| OPEN BUY ORDER                                                   |
//+------------------------------------------------------------------+
      if(BuyCondition)
      {
         ticket        = subOpenOrder(OP_BUY,StopLoss,TakeProfit,TicketComment); // open BUY order
         subCheckError(ticket,"BUY");
         LastTrade     = "BUY";
         return(0);
      }

//+------------------------------------------------------------------+
//| OPEN SELL ORDER                                                  |
//+------------------------------------------------------------------+
      if(SellCondition)
      {
         ticket        = subOpenOrder(OP_SELL,StopLoss,TakeProfit,TicketComment); // open SELL order
         subCheckError(ticket,"SELL");
         LastTrade     = "SELL";
         return(0);
      }
   }

//+------------------------------------------------------------------+
//| IF THERE IS NOTHING ELSE GO TO START                             |
//+------------------------------------------------------------------+
   return(0);
}

//+------------------------------------------------------------------+
//| END PROGRAM                                                      |
//+------------------------------------------------------------------+



//+------------------------------------------------------------------+
//| FUNCTION DEFINITIONS                                             |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//| FUNCTION : MONEY MANAGEMENT                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
double subLotSize()
{
     double lotMM = MathCeil(AccountFreeMargin() *  Risk / 1000) / 100;
	  
	  if(AccountIsMicro==false) //normal account
	  {
	     if(lotMM < 0.1)                  lotMM = Lots;
	     if((lotMM > 0.5) && (lotMM < 1)) lotMM = 0.5;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  else //micro account
	  {
	     if(lotMM < 0.01)                 lotMM = Lots;
	     if(lotMM > 1.0)                  lotMM = MathCeil(lotMM);
	     if(lotMM > 100)                  lotMM = 100;
	  }
	  
	  return (lotMM);
}

//+------------------------------------------------------------------+
//| FUNCTION : NUMBER OF ORDER BASE ON SYMBOL AND MAGIC NUMBER       |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subOrdersTotal()
{
   int
      cnt, 
      total,
      ordertotal;

   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber) ordertotal++;
   }
   return(ordertotal);
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK OPEN ORDER BASE ON SYMBOL AND MAGIC NUMBER      |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
string subCheckOpenTrade()
{
   int
      cnt, 
      total;

   string
      lasttrade   = "None";      

   total = OrdersTotal();
   for(cnt=0;cnt<total;cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY ) lasttrade = "BUY";
         if(OrderType()==OP_SELL) lasttrade = "SELL";
      }         
   }
   return(lasttrade);
}

//+------------------------------------------------------------------+
//| FUNCTION : OPEN ORDER                                            |
//| SOURCE   : CODERSGURU, PENGIE                                    |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subOpenOrder(int type, int mStopLoss, int mTakeProfit, string mTicketComment)
{
   int
         ticket      = 0,
         err         = 0,
         c           = 0;
         
   double         
         aStopLoss   = 0,
         aTakeProfit = 0,
         bStopLoss   = 0,
         bTakeProfit = 0;

   if(mStopLoss!=0)
   {
      aStopLoss   = NormalizeDouble(Ask-mStopLoss*Point,4);
      bStopLoss   = NormalizeDouble(Bid+mStopLoss*Point,4);
   }
   
   if(mTakeProfit!=0)
   {
      aTakeProfit = NormalizeDouble(Ask+mTakeProfit*Point,4);
      bTakeProfit = NormalizeDouble(Bid-mTakeProfit*Point,4);
   }
   
   if(type==OP_BUY)
   {
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,aStopLoss,aTakeProfit,mTicketComment,MagicNumber,0,Green);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }
   if(type==OP_SELL)
   {   
      for(c=0;c<NumberOfTries;c++)
      {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,bStopLoss,bTakeProfit,mTicketComment,MagicNumber,0,Red);
         err=GetLastError();
         if(err==0)
         { 
            break;
         }
         else
         {
            if(err==4 || err==136 || err==137 || err==138 || err==146) //Busy errors
            {
               Sleep(5000);
               continue;
            }
            else //normal error
            {
               break;
            }  
         }
      }   
   }  
   return(ticket);
}

//+------------------------------------------------------------------+
//| FUNCTION : CLOSE ORDER                                           |
//| SOURCE   : n/a                                                   |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
void subCloseOrder()
{
   int
      cnt, 
      total;

   total = OrdersTotal();
   for(cnt=total-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         switch(OrderType())
         {
            case OP_BUY      :
               OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
               break;
               
            case OP_SELL     :
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
               break;
         }
      }
   }      
}

//+------------------------------------------------------------------+
//| FUNCTION : TRAILING STOP                                         |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
void subTrailingStop()
{
   int
      cnt, 
      total;

   total = OrdersTotal();
   for(cnt=0;cnt<OrdersTotal();cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL &&
         OrderSymbol()==Symbol() &&
         OrderMagicNumber()==MagicNumber)
      {
         if(OrderType()==OP_BUY)   // buy position is opened   
         {
            if(Bid-OrderOpenPrice()>Point*TrailingStop &&
               OrderStopLoss()<Bid-Point*TrailingStop)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
               return(0);
            }
         }

         if(OrderType()==OP_SELL)   // sell position is opened   
         {
            if(OrderOpenPrice()-Ask>Point*TrailingStop)
            {
            if(OrderStopLoss()>Ask+Point*TrailingStop || OrderStopLoss()==0)
            {
               OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
               return(0);
            }
            }
         }
      }
   }               
}

//+------------------------------------------------------------------+
//| FUNCTION : CHECK ERROR CODE                                      |
//| SOURCE   : CODERSGURU                                            |
//| MODIFIED : n/a                                                   |
//+------------------------------------------------------------------+
void subCheckError(int ticket, string Type)
{
   if(ticket>0) 
   {
//      if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(Type + " order opened : ",OrderOpenPrice());
   }
   else Print("Error opening " + Type + " order : ", ErrorDescription(GetLastError()));
}

//+------------------------------------------------------------------+
//| FUNCTION : GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME   |
//| SOURCE   : PENGIE                                                |
//| MODIFIED : FIREDAVE                                              |
//+------------------------------------------------------------------+
int subGenerateMagicNumber(int MagicNumber, string symbol, int timeFrame)
{
   int isymbol = 0;
        if (symbol == "EURUSD")  isymbol = 10;
   else if (symbol == "GBPUSD")  isymbol = 20;
   else if (symbol == "USDJPY")  isymbol = 30;
   else if (symbol == "USDCHF")  isymbol = 40;
   else if (symbol == "AUDUSD")  isymbol = 50;
   else if (symbol == "USDCAD")  isymbol = 60;
   else if (symbol == "EURGBP")  isymbol = 11;
   else if (symbol == "EURJPY")  isymbol = 12;
   else if (symbol == "EURCHF")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "GBPJPY")  isymbol = 21;
   else if (symbol == "GBPCHF")  isymbol = 22;
   else if (symbol == "GBPAUD")  isymbol = 23;
   else if (symbol == "GBPCAD")  isymbol = 24;
   else                          isymbol = 99;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
}

//+------------------------------------------------------------------+
//| END FUNCTION                                                     |
//+------------------------------------------------------------------+

